# x265enc

This element encodes raw video into H265 compressed data.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstVideoEncoder
                        ╰──x265enc

## Implemented interfaces

    GstPreset

## Factory details

Authors: – Thijs Vermeir

Classification: – `Codec/Encoder/Video`

Rank – primary

Plugin – x265

Package – GStreamer Bad Plug-ins

## Pad Templates

### `sink`

    video/x-raw:
          framerate: [ 0/1, 2147483647/1 ]
              width: [ 16, 2147483647 ]
             height: [ 16, 2147483647 ]
             format: { Y444, Y42B, I420, Y444_10LE, I422_10LE, I420_10LE, Y444_12LE, I422_12LE, I420_12LE }

Presence – always

Direction – sink

Object type – GstPad

### `src`

    video/x-h265:
          framerate: [ 0/1, 2147483647/1 ]
              width: [ 16, 2147483647 ]
             height: [ 16, 2147483647 ]
      stream-format: byte-stream
          alignment: au
            profile: { (string)main, (string)main-still-picture, (string)main-intra, (string)main-444, (string)main-444-intra, (string)main-444-still-picture, (string)main-10, (string)main-10-intra, (string)main-422-10, (string)main-422-10-intra, (string)main-444-10, (string)main-444-10-intra, (string)main-12, (string)main-12-intra, (string)main-422-12, (string)main-422-12-intra, (string)main-444-12, (string)main-444-12-intra }

Presence – always

Direction – src

Object type – GstPad

## Properties

### bitrate

    “bitrate” guint

Bitrate in kbit/sec

Flags : Read / Write

Default value : 2048

### key-int-max

    “key-int-max” gint

Maximal distance between two key-frames (0 = x265 default / 250)

Flags : Read / Write

Default value : 0

### log-level

    “log-level” GstX265LogLevel *

x265 log level

Flags : Read / Write

Default value : none (-1)

### option-string

    “option-string” gchararray

String of x265 options (overridden by element properties) in the format "key1=value1:key2=value2".

Flags : Read / Write

### qp

    “qp” gint

QP for P slices in (implied) CQP mode (-1 = disabled)

Flags : Read / Write

Default value : -1

### speed-preset

    “speed-preset” GstX265SpeedPreset *

Preset name for speed/quality tradeoff options

Flags : Read / Write

Default value : medium (6)

### tune

    “tune” GstX265Tune *

Preset name for tuning options

Flags : Read / Write

Default value : ssim (2)

## Named constants

### GstX265LogLevel

#### Members

`none` (-1) – No logging
`error` (0) – Error
`warning` (1) – Warning
`info` (2) – Info
`debug` (3) – Debug
`full` (4) – Full

### GstX265SpeedPreset

#### Members

`No preset` (0) – No preset
`ultrafast` (1) – ultrafast
`superfast` (2) – superfast
`veryfast` (3) – veryfast
`faster` (4) – faster
`fast` (5) – fast
`medium` (6) – medium
`slow` (7) – slow
`slower` (8) – slower
`veryslow` (9) – veryslow
`placebo` (10) – placebo

### GstX265Tune

The results of the search are